import tkinter as tk

# Fonction pour afficher les résultats
def afficher_resultats():
    # Supprimer les anciens résultats s'il y en a
    effacer_resultats()

    # Supposons que vous ayez des résultats dans une liste
    resultats = ["Résultat 1", "Résultat 2", "Résultat 3"]

    # Afficher chaque résultat dans un label
    for i, resultat in enumerate(resultats):
        label_resultat = tk.Label(fenetre, text=resultat)
        label_resultat.pack()

# Fonction pour effacer les résultats précédents
def effacer_resultats():
    # Supprimer tous les labels précédents
    for widget in fenetre.winfo_children():
        if isinstance(widget, tk.Label):
            widget.pack_forget()

# Interface graphique
fenetre = tk.Tk()
fenetre.title("Affichage de résultats")

# Bouton pour afficher les résultats
bouton_afficher_resultats = tk.Button(fenetre, text="Afficher les résultats", command=afficher_resultats)
bouton_afficher_resultats.pack(pady=10)

fenetre.mainloop()